<template>
	<div class="mod-config">
		<el-form
			:inline="true"
			:model="dataForm"
			@keyup.enter.native="getDataList()"
		>
			<el-form-item>
				<el-input
					v-model="dataForm.key"
					placeholder="设备名称/设备编码"
					clearable
				></el-input>
			</el-form-item>
			<el-form-item>
				<el-button @click="getDataList()">{{ $t('search') }}</el-button>
				<el-button
					v-if="$hasPermission('monitoring:equipment:save')"
					type="primary"
					@click="addOrUpdateHandle()"
					>{{ $t('add') }}</el-button
				>
				<el-button @click="exportHandle()">导出</el-button>
			</el-form-item>
		</el-form>

		<base-table
			:data="dataList"
			:table-head-configs="tableConfigs"
			:max-height="calcMaxHeight(8)"
			@operate-event="handleOperations"
			@refreshDataList="getDataList"
		/>
		<el-pagination
			@size-change="sizeChangeHandle"
			@current-change="currentChangeHandle"
			:current-page="pageIndex"
			:page-sizes="[10, 20, 50, 100]"
			:page-size="pageSize"
			:total="totalPage"
			layout="total, sizes, prev, pager, next, jumper"
		></el-pagination>
		<!-- 弹窗, 新增 / 修改 -->
		<add-or-update
			v-if="addOrUpdateVisible"
			ref="addOrUpdate"
			:configs="addOrUpdateConfigs"
			@refreshDataList="getDataList"
			@destory-dialog="addOrUpdateVisible = false"
		/>
	</div>
</template>

<script>
import i18n from '@/i18n'
import AddOrUpdate from '@/components/base-dialog/addOrUpdate'
// import AddOrUpdate from './equipment-add-or-update'
import BaseTable from '@/components/base-table'
import TableOperateComponent from '@/components/base-table/components/operationComponent'
import TableTextComponent from '@/components/base-table/components/detailComponent'
import moment from 'moment'
import CKEditor from 'ckeditor4-vue'
import { calcMaxHeight } from '@/utils'

const tableConfigs = [
	{
		type: 'index',
		name: '序号'
		// more: {
		// 	index: function(index) {
		// 		return (index + 1) * 2
		// 	}
		// }
	},
	{
		prop: 'createTime',
		name: i18n.t('createTime'),
		filter: val => moment(val).format('YYYY-MM-DD HH:mm:ss')
	},
	{ prop: 'name', name: '设备名称' },
	{ prop: 'code', name: '设备编码' },
	{ prop: 'equipmentTypeName', name: '设备类型' },
	{ prop: 'groupName', name: '设备分组' },
	{ prop: 'enName', name: '英文名称' },
	{ prop: 'abbr', name: '缩写' },
	{
		prop: 'details',
		name: '详情',
		subcomponent: TableTextComponent,
		actionName: 'view-detail'
	},
	{
		prop: 'operations',
		name: '操作',
		fixed: 'right',
		width: 180,
		subcomponent: TableOperateComponent,
		options: ['edit', 'delete']
	}
]

const addOrUpdateConfigs = {
	type: 'dialog',
	infoUrl: '/monitoring/equipment',
	fields: [
		{ name: 'name', label: '设备名称', required: true },
		{ name: 'code', label: '设备编码' },
		{ name: 'enName', label: '英文名称' },
		{ name: 'abbr', label: '缩写' },
		{
			name: 'equipmentTypeId',
			label: '设备类型',
			required: true,
			type: 'select',
			options: []
		},
		{
			name: 'groupId',
			label: '设备分组',
			required: true,
			type: 'select',
			options: []
		},
		{
			name: 'productionTime',
			label: '生产日期',
			type: 'date',
			props: {
				'type': 'date', // element-ui 的配置
				'placeholder': '请选择日期',
				'value-format': 'yyyy-MM-ddTHH:mm:ss',
				'style': {
					width: '100%'
				}
			}
		},
		{
			name: 'enterTime',
			label: '进厂日期',
			type: 'date',
			props: {
				'type': 'date', // element-ui 的配置
				'placeholder': '请选择日期',
				'value-format': 'yyyy-MM-ddTHH:mm:ss',
				'style': {
					width: '100%'
				}
			}
		},
		{
			name: 'tvalue',
			label: '设备TT值',
			required: true,
			rules: [
				{
					type: 'number',
					message: '请输入正确的浮点值',
					trigger: 'blur',
					transform: val => Number(val)
				}
			]
		},
		{
			name: 'processingTime',
			label: '单件产品加工时间(秒)',
			rules: [
				{
					type: 'number',
					message: '请输入正确的数值',
					trigger: 'blur',
					transform: val => Number(val)
				}
			]
		},
		{ name: 'manufacturer', label: '制造商' },
		{ name: 'spec', label: '设备规格' },
		{
			name: 'dataType',
			label: '数据类别',
			required: true,
			type: 'select',
			options: [
				{ value: 0, label: '无类别' },
				{ value: 1, label: '上片数据设备' },
				{ value: 2, label: '下片数据设备' }
			]
		},
		{ name: 'remark', label: '备注 ' }
	],
	// TODO: 富文本  √
	// TODO: 设备资料上传 √
	// TODO: 设备图片上传 √
	extraComponents: [
		{
			name: 'description',
			hasModel: true,
			label: '功能描述',
			fieldType: 'string',
			component: CKEditor.component,
			props: {
				value: 'tests',
				config: {
					// ckeditor 的配置: https://ckeditor.com/docs/ckeditor4/latest/api/CKEDITOR_config.html
					// toolbar: [['Bold']]
				}
			}
		},
		{
			name: 'files',
			label: '上传资料',
			fieldType: 'array',
			component: () => import('@/components/base-upload'),
			props: {
				// 上传组件需要的 props
				url: '/monitoring/attachment/uploadFileFormData',
				extraParams: { typeCode: 'EquipmentInfoFile' },
				buttonContent: '点击上传',
				tip: '上传文件大小不要超过 2mb (2048kb)'
			}
		},
		{
			name: 'files',
			label: '设备图片',
			fieldType: 'array',
			component: () => import('@/components/base-upload'),
			props: {
				// 上传组件需要的 props
				url: '/monitoring/attachment/uploadFileFormData',
				extraParams: { typeCode: 'EquipmentInfoImage' },
				buttonContent: '点击上传',
				tip: '上传图片文件，且大小不要超过 2mb (2048kb)'
			}
		}
	],
	subtable: {
		title: '查看设备属性',
		url: '/monitoring/equipmentAttr',
		relatedField: 'equipmentId',
		tableConfigs: [
			{ type: 'index', name: '序号' },
			{ prop: 'createTime', name: '创建时间' },
			{ prop: 'attrName', name: '属性名称', formField: true },
			{ prop: 'attrValue', name: '属性值', formField: true },
			{
				prop: 'operations',
				name: '操作',
				fixed: 'right',
				width: 180,
				subcomponent: TableOperateComponent,
				options: ['edit', 'delete']
			}
		]
	},
	operations: [
		{ name: 'cancel', showAlways: true },
		{
			name: 'save',
			url: '/monitoring/equipment',
			permission: '',
			showOnEdit: false
		},
		{
			name: 'update',
			url: '/monitoring/equipment',
			permission: '',
			showOnEdit: true
		}
	]
}

const i18nLocal = {
	messages: {
		'en': { search: 'Search', add: 'Add', createTime: 'create time' },
		'zh-CN': { search: '查询', add: '新建', createTime: '创建时间' }
	}
}

export default {
	i18n: i18nLocal,
	data() {
		return {
			calcMaxHeight,
			tableConfigs,
			addOrUpdateConfigs,
			dataForm: {
				key: ''
			},
			dataList: [],
			pageIndex: 1,
			pageSize: 10,
			totalPage: 0,
			dataListLoading: false,
			dataListSelections: [],
			addOrUpdateVisible: false
		}
	},
	components: {
		AddOrUpdate,
		BaseTable
	},
	activated() {
		console.log('activated')
		this.getDataList()
		this.getGroupList()
		this.getTypeList()
	},
	methods: {
		// 获取设备类型列表
		getTypeList() {
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipmentType/page'),
				method: 'get',
				params: this.$http.adornParams({
					// page: this.pageIndex,
					// limit: this.pageSize,
					// key: this.dataForm.key
				})
			}).then(({ data }) => {
				const eqTypeConfig = this.addOrUpdateConfigs.fields.find(
					item => item.name === 'equipmentTypeId'
				)
				eqTypeConfig.options =
					data.data?.list?.map(item => ({
						value: item.id,
						label: item.name
					})) || []
			})
		},
		// 获取设备分组列表
		getGroupList() {
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipmentGroup/page'),
				method: 'get',
				params: this.$http.adornParams({
					// page: this.pageIndex,
					// limit: this.pageSize,
					// key: this.dataForm.key
				})
			}).then(({ data }) => {
				const groupConfig = this.addOrUpdateConfigs.fields.find(
					item => item.name === 'groupId'
				)
				groupConfig.options =
					data.data?.list?.map(item => ({
						value: item.id,
						label: item.name
					})) || []
			})
		},
		// 获取数据列表
		getDataList() {
			this.dataListLoading = true
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipment/page'),
				method: 'get',
				params: this.$http.adornParams({
					page: this.pageIndex,
					limit: this.pageSize,
					key: this.dataForm.key
				})
			}).then(({ data }) => {
				if (data && data.code === 0) {
					// this.dataList = data.data.list
					this.dataList = new Array(20).fill('1')
					console.log('data list', this.dataList)
					this.totalPage = data.data.total
				} else {
					this.dataList = []
					this.totalPage = 0
				}
				this.dataListLoading = false
			})
		},
		// 每页数
		sizeChangeHandle(val) {
			this.pageSize = val
			this.pageIndex = 1
			this.getDataList()
		},
		// 当前页
		currentChangeHandle(val) {
			this.pageIndex = val
			this.getDataList()
		},
		// 多选
		selectionChangeHandle(val) {
			this.dataListSelections = val
		},
		handleOperations({ type, data: id }) {
			switch (type) {
				case 'view-detail':
					// const { name, code } = this.dataList.find(item => item.id === id)
					// this.$router.push({
					// 	name: 'monitoring-equipmentAdd',
					// 	params: {
					// 		isdetail: true,
					// 		equipmentId: id
					// 	}
					// })
					// break
					return this.addOrUpdateHandle(id, true)
				case 'edit':
					return this.addOrUpdateHandle(id)
				case 'delete':
					return this.deleteHandle(id)
			}
		},
		exportHandle() {
			// this.$http.get(this.$http.adornUrl('/monitoring/equipment/export')).then(({ data: res }) => {
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipment/export'),
				method: 'get',
				responseType: 'blob'
			}).then(res => {
				let fileName = 'equipment-list.xls'
				if (res.headers['content-disposition']) {
					const contentDisposition = res.headers['content-disposition']
					fileName = contentDisposition.slice(
						contentDisposition.indexOf('filename=') + 9
					)
				}

				fileName = decodeURIComponent(fileName)

				const blob = new Blob([res.data])

				if ('download' in document.createElement('a')) {
					const alink = document.createElement('a')
					alink.download = fileName
					alink.style.display = 'none'
					alink.target = '_blank'
					alink.href = URL.createObjectURL(blob)
					document.body.appendChild(alink)
					alink.click()
					URL.revokeObjectURL(alink.href)
					document.body.removeChild(alink)
				} else {
					navigator.msSaveBlob(blob, fileName)
				}
			})
		},
		// 新增 / 修改
		addOrUpdateHandle(id, isdetail = false) {
			this.addOrUpdateVisible = true
			this.$nextTick(() => {
				this.$refs.addOrUpdate.init(id, isdetail)
			})
			// this.$router.push({
			// 	name: 'monitoring-equipmentAdd',
			// 	params: {
			// 		equipmentId: id
			// 	}
			// })
		},
		// 删除
		deleteHandle(id) {
			var ids = id
				? [id]
				: this.dataListSelections.map(item => {
						return item.id
				  })
			this.$confirm(
				`确定对[id=${ids.join(',')}]进行[${id ? '删除' : '批量删除'}]操作?`,
				'提示',
				{
					confirmButtonText: '确定',
					cancelButtonText: '取消',
					type: 'warning'
				}
			).then(() => {
				this.$http({
					url: this.$http.adornUrl('/monitoring/equipment'),
					method: 'delete',
					data: this.$http.adornData(ids, false, 'raw')
				}).then(({ data }) => {
					if (data && data.code === 0) {
						this.$message({
							message: '操作成功',
							type: 'success',
							duration: 1500,
							onClose: () => {
								this.getDataList()
							}
						})
					} else {
						this.$message.error(data.msg)
					}
				})
			})
		}
	}
}
</script>
